<template>
  <q-page padding>
    <!-- content -->
    <q-dialog :value="showDialog">
      <q-card style="min-width: 300px">
        <q-card-section>
          <div class="text-h6">Add Action</div>
        </q-card-section>

        <q-card-section>
          <q-select
            v-model="newAction.type"
            :options="crudTypes"
            borderless
            label="Choose the type of action"
          />
        </q-card-section>

        <q-card-section>
          <q-input
            v-model="newAction.description"
            label="What action needs to be taken?"
            autofocus
            clearable
            dense
          />
        </q-card-section>
        <q-input
          filled
          v-model="newAction.time"
          :style="{margin: 'auto', width: '90%'}"
        >
          <template v-slot:prepend>
            <q-icon
              name="event"
              class="cursor-pointer"
            >
              <q-popup-proxy
                transition-show="scale"
                transition-hide="scale"
              >
                <q-date
                  today-btn
                  v-model="newAction.time"
                  mask="YYYY-MM-DD HH:mm"
                />
              </q-popup-proxy>
            </q-icon>
          </template>

          <template v-slot:append>
            <q-icon
              name="access_time"
              class="cursor-pointer"
            >
              <q-popup-proxy
                transition-show="scale"
                transition-hide="scale"
              >
                <q-time
                  v-model="newAction.time"
                  mask="YYYY-MM-DD HH:mm"
                  format24h
                />
              </q-popup-proxy>
            </q-icon>
          </template>
        </q-input>
        <q-card-section>

        </q-card-section>

        <q-card-actions
          align="right"
          class="text-primary"
        >
          <q-btn
            flat
            label="Cancel"
            @click="cancel()"
          />
          <q-btn
            flat
            label="Add Todo"
            @click="addAction(patient, newAction)"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <div class="form">
      <q-card>
        <q-card-section>
          <div class="flex flex-center">
            <q-avatar
              size="130px"
              v-if="this.patient.picture !==''"
            >
              <img
                :src='"http://localhost:3000/" + this.patient.picture'
                alt=""
              >
            </q-avatar>
            <q-avatar
              size="130px"
              color="grey"
              v-else
            >
              {{this.patient.name.charAt(0)}}
            </q-avatar>
            <div class="profile">
              <div class="text-h6">{{ patient.name }}</div>
              <div class="text-subtitle"><b>Floor: {{ deptName }} &emsp; Room: {{ roomNumber }}</b></div>
              <div>
                <q-icon name="favorite_border"></q-icon>
                {{ patient.heartrate }}
                &emsp;
                <q-icon name="fas fa-heartbeat"></q-icon>
                {{ patient.bloodpressure }}
              </div>
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-section>
          <div>
            <q-item-label header>Date of registration: </q-item-label>
            <q-input
              class="info"
              dense
              readonly
              v-model="patient.registrationDate"
            />
          </div>
          <div>
            <q-item-label header>Reason of registration: </q-item-label>
            <q-input
              class="info"
              dense
              readonly
              v-model="patient.reason"
            />
          </div>
          <div>
            <q-item-label header>Attending Physician </q-item-label>
            <q-input
              class="info"
              dense
              readonly
              v-model="doctor.name"
            />
          </div>
          <div :style="{ display: 'flex'}">
            <q-item-label header>Vegetarian: </q-item-label>
            <q-checkbox
              v-model="patient.vegetarian"
              v-on:click.native="updatePatient(patient)"
            />
          </div>
        </q-card-section>
        <q-card-section>
          <q-item-label header>
            Actions
            <q-btn
              round
              dense
              flat
              icon='add'
              @click="showDialog = true"
            />
          </q-item-label>
          <q-item-label header>
            Hide completed actions
            <q-toggle
              v-model="showDone"
              checked-icon="check"
              color="green"
              unchecked-icon="clear"
            />
          </q-item-label>
          <div class="actionController">
            <q-list>
              <q-item
                v-for="(action, index) in filteredActions"
                :key="index"
              >
                <q-item-section>
                  <div>
                    <q-input
                      readonly
                      v-model="action.time"
                    >
                      <template v-slot:prepend>
                        <q-icon
                          name="event"
                          class="cursor-pointer"
                        >
                          <q-popup-proxy
                            transition-show="scale"
                            transition-hide="scale"
                          >
                            <q-date
                              today-btn
                              v-model="action.time"
                              mask="YYYY-MM-DD HH:mm"
                            />
                          </q-popup-proxy>
                        </q-icon>
                      </template>

                      <template v-slot:append>
                        <q-icon
                          name="access_time"
                          class="cursor-pointer"
                        >
                          <q-popup-proxy
                            transition-show="scale"
                            transition-hide="scale"
                          >
                            <q-time
                              v-model="action.time"
                              mask="YYYY-MM-DD HH:mm"
                              format24h
                            />
                          </q-popup-proxy>
                        </q-icon>
                      </template>
                    </q-input>
                  </div>
                </q-item-section>
                <q-item-section :class="{'hidden' : editing}">
                  <q-item-label>{{action.type}}</q-item-label>
                </q-item-section>
                <q-item-section :class="{'hidden' : !editing}">
                  <q-select
                    v-model="action.type"
                    :options="types"
                    borderless
                    label="Choose the type of action"
                  />
                </q-item-section>
                <q-item-section :class="{'hidden' : editing}">
                  <q-item-label>{{action.description}}</q-item-label>
                </q-item-section>
                <q-item-section :class="{'hidden' : !editing}">
                  <q-input
                    autogrow
                    filled
                    v-model="action.description"
                  />
                </q-item-section>
                <q-item-section>
                  <q-checkbox
                    v-model="action.done"
                    v-on:click.native="updatePatientAction(action)"
                    color="positive"
                  />
                </q-item-section>
                <q-item-section>
                  <q-btn
                    v-if="!editing"
                    round
                    flat
                    icon="edit"
                    color="warning"
                    @click="() => {
                      editing = true
                    }"
                  />
                  <q-btn
                    v-if="editing"
                    round
                    flat
                    icon="check"
                    color="positive"
                    @click="()=>{
                      updatePatientAction(action)
                      editing = false
                    }"
                  />
                </q-item-section>
              </q-item>
            </q-list>
          </div>
        </q-card-section>
        <q-card-section>
          <div class="commentContainer">
            <q-list>
              <q-item-label header>Comments</q-item-label>
              <q-item
                v-for="(comm, index) in patient.comments"
                :key="index"
              >
                <q-item-section>
                  <q-item-label>
                    <q-icon name="far fa-calendar-alt" /> &ensp;
                    {{new Date(comm.date).toLocaleString('en-GB')}}</q-item-label>
                </q-item-section>
                <q-item-section :class="{'hidden' : editing}">
                  <q-item-label>{{comm.message}}</q-item-label>
                </q-item-section>
                <q-item-section :class="{'hidden' : !editing}">
                  <q-input
                    autogrow
                    filled
                    v-model="comm.message"
                  />
                </q-item-section>
                <q-item-section>
                  <q-btn
                    v-if="!editing"
                    round
                    flat
                    icon="edit"
                    color="warning"
                    @click="() => {
                      editing = true
                    }"
                  />
                  <q-btn
                    v-if="editing"
                    round
                    flat
                    icon="check"
                    color="positive"
                    @click="()=>{
                      updateComment(patient, comm.id, comm.message)
                      editing = false
                    }"
                  />
                </q-item-section>
              </q-item>
            </q-list>
            <div :style="{ display: 'flex'}">
              <q-input
                :style="{ margin: '10px', width: '95%' }"
                filled
                placeholder="Enter your comment"
                v-model="message"
              />
              <q-btn
                round
                flat
                color="primary"
                icon="send"
                @click="() => {
                  newComment.message = message
                  addComment(patient, newComment)
                }"
              />
            </div>
          </div>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>

<script>
import HospitalService from '../services/HospitalService'
import ErrorService from '../services/ErrorService'

export default {
  name: 'RoomDetail',
  props: ['patientId', 'roomNumber', 'deptName'],
  data: () => ({
    patient: null,
    doctor: null,
    date: null,
    showDone: false,
    message: '',
    editing: false,
    newComment: {
      id: 0,
      message: '',
      date: Date.now().toLocaleString('en-GB')
    },
    newAction: {
      id: 0,
      type: '',
      description: '',
      time: '',
      done: false
    },
    showDialog: false,
    types: [
      'Medication', // not crud
      'Injection', // not crud
      'Infusion', // not crud
      'Food',
      'Wash',
      'Reverse against bedsores'
    ],
    crudTypes: [
      'Food',
      'Wash',
      'Reverse against bedsores'
    ]
  }),
  created () {
    this.hospitalService = new HospitalService()
    this.loadPatient(this.patientId)
  },
  watch: {
    patientId (newVal) {
      this.loadPatient(newVal)
    }
  },
  methods: {
    async loadPatient (patientId) {
      try {
        this.patient = await this.hospitalService.getPatient(patientId)
        this.getDoctor(this.patient.doctor)
        this.newComment.message = ''
        this.message = ''
      } catch (e) {
        ErrorService.showAlert('Loading of patient failed')
      }
    },
    async updatePatient (patient) {
      try {
        await this.hospitalService.updatePatient(patient)
      } catch {
        ErrorService.showAlert('Unable to update patient')
      }
    },
    async updatePatientAction (action) {
      try {
        let p = this.patient

        p.actions[action.id] = action

        await this.hospitalService.updatePatient(p)
      } catch {
        ErrorService.showAlert('Unable to update patient')
      }
    },
    async getDoctor (id) {
      try {
        this.doctor = await this.hospitalService.getDoctor(id)
      } catch (e) {
        ErrorService.showAlert('Loading of doctor failed')
      }
    },
    async updateComment (patient, id, message) {
      try {
        await this.hospitalService.updatePatient(patient)
      } catch {
        ErrorService.showAlert('Unable to update comment')
      }
    },
    async addComment (patient, comment) {
      try {
        comment.id = patient.comments.length === 0 ? 0 : patient.comments.length

        patient.comments.push(comment)

        await this.hospitalService.updatePatient(patient)
      } catch {
        ErrorService.showAlert('Unable to add comment')
      }
      this.loadPatient(patient.id)
    },
    cancel () {
      this.showDialog = false
    },
    async addAction (patient, action) {
      try {
        this.showDialog = false
        if (new Date(action.time).getTime() > Date.now()) {
          action.id = patient.actions.length === 0 ? 0 : patient.actions.length

          patient.actions.push(action)

          await this.hospitalService.updatePatient(patient)
        } else {
          ErrorService.showAlert('Date must be in the future')
        }
      } catch {
        ErrorService.showAlert('Unable to add action')
      }
    }
  },
  computed: {
    filteredActions () {
      return this.patient.actions.filter(action => !this.showDone || !action.done)
    },
    filteredCrudActions () {
      return this.types
    }
  }
}
</script>

<style lang="css" scoped>
q-page {
  font-family: "Roboto", serif;
}
.form {
  width: 80%;
  margin: 0 auto;
}
.container {
  display: flex;
  justify-content: baseline;
}
.actionController {
  width: 100%;
}
.action {
  max-width: 360px;
  margin: 15px;
  padding: 10px;
}
.profile {
  margin: 10px;
}

.info {
  margin: 0 15px;
}

@media screen and (max-width: 980px) {
  .actionController {
    display: flex;
    flex-direction: column;
  }
}
</style>
